import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Scanner;

class Main {

	// Adjacency list representation of the graph
	static int n;
	static ArrayList<Integer> graph[];
	static int[][] capacity, flow;

	// Computes the value of a maximum flow
	public static int computeMaximumFlow() {
		int maxFlow = 0;
		//your implementation goes here

		return maxFlow;
	}

	public static void main(String[] args) {
		int test, ntest, m, u, v, c, i, maxFlow;
		Scanner sc = new Scanner(System.in);
		ntest = sc.nextInt();
		for(test = 1; test <= ntest; test++) {
			// Read the number of vertices
			n = sc.nextInt();
			// Read the number of edges
			m = sc.nextInt();

			// Initialize the graph
			capacity = new int[n][n];
			flow = new int[n][n];
			graph = (ArrayList<Integer>[])new ArrayList[n];
			for(i = 0; i < n; i++)
				graph[i] = new ArrayList<Integer>();

			// Add the input edges to the graph
			for(i = 0; i < m; i++) {
				u = sc.nextInt();
				v = sc.nextInt();
				c = sc.nextInt();

				// Index vertices internally from 0 to n-1 (instead of 1..n)
				u--; v--;

				// Initialize capacity, flow and store adjacency list
				capacity[u][v] = c;
				flow[u][v] = 0;
				graph[u].add(v);
				capacity[v][u] = 0;
				graph[v].add(u);
			}

			// Compute maximum flow
			maxFlow = computeMaximumFlow();

			// Output result
			System.out.println(maxFlow);
		}
	}

}
